'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FSHelper = undefined;

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _events = require('events');

var _untildify = require('untildify');

var _untildify2 = _interopRequireDefault(_untildify);

var _events2 = require('../../conf/events');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const fsEvents = _events2.FS.REMOTE;

class FSHelper extends _events.EventEmitter {

  constructor() {
    super();
  }

  addFile(message) {
    _fsExtra2.default.outputFile((0, _untildify2.default)(message.destinationpath), message.contents, err => {
      if (err) return this.emit(fsEvents.ADD_FILE_ERROR, err);

      this.emit(fsEvents.ADD_FILE, message.destinationpath);
    });
  }

  addDir(message) {
    _fsExtra2.default.mkdirs((0, _untildify2.default)(message.destinationpath), err => {
      if (err) return this.emit(fsEvents.ADD_DIR_ERROR, err);

      this.emit(fsEvents.ADD_DIR, message.destinationpath);
    });
  }

  removePath(message) {
    _fsExtra2.default.remove((0, _untildify2.default)(message.destinationpath), err => {
      if (err) return this.emit(fsEvents.DELETE_ERROR, err);

      this.emit(fsEvents.DELETE, message.destinationpath);
    });
  }
}
exports.FSHelper = FSHelper;